<template>
  <div v-if="searchSuggestions.length" class="flex bg-white shadow-md p-1 rounded-md shadow-md flex-wrap">
    <span
        class="inline-flex items-center px-2 m-1 rounded-md text-xs font-medium bg-gray-300 text-gray-800 cursor-pointer"
        v-for="(searchSuggestion, idx) in searchSuggestions" :key="idx"
        @click="selectSuggestion(searchSuggestion.Symbol)"
    >
      {{ searchSuggestion.Symbol }}
    </span>
  </div>
</template>

<script>
import {getCurrencyList} from "@/api/subscriptionsApi";

export default {
  name: "SearchSuggestions",

  props: {
    searchValue: String
  },

  emits: ["suggestion", "suggestionSelected"],

  data() {
    return {
      searchSuggestions: [],
      currencyList: []
    }
  },

  methods: {
    selectSuggestion(tickerSymbol) {
      this.$emit("suggestionSelected", tickerSymbol);
    },

    handleSearchSuggestions(searchValue) {
      if (this.searchTimerId) {
        clearTimeout(this.searchTimerId);
        this.breakSearch = true;
      }
      if (searchValue && searchValue.length >= 2) {
        this.searchTimerId = setTimeout(() => {
          this.breakSearch = false;
          this.searchTicker(searchValue, 4);
        }, 500);
      }
    },

    searchTicker(searchString, searchLimit) {
      if (this.currencyList.length) {
        const resultArray = [];
        for (let i = 0; i <= this.currencyList.length; i++) {
          if (resultArray.length >= searchLimit || this.breakSearch) {
            break;
          }
          let element = this.currencyList[i];
          if (element && element.Symbol.search(new RegExp(searchString, 'i')) !== -1) {
            resultArray.push(element);
          }
        }
        for (let i = 0; i <= this.currencyList.length; i++) {
          if (resultArray.length >= searchLimit || this.breakSearch) {
            break;
          }
          let element = this.currencyList[i];
          if (element && element.FullName.search(new RegExp(searchString, 'i')) !== -1) {
            if (resultArray.indexOf(element) === -1) {
              resultArray.push(element);
            }
          }
        }
        this.searchSuggestions = resultArray;
      }
    },

    async loadCurrencyListFromApi() {
      this.currencyList = await getCurrencyList();
    }
  },

  watch: {
    searchValue() {
      if (!this.searchValue) {
        this.searchSuggestions = [];
      }
      this.handleSearchSuggestions(this.searchValue);
    },

    searchSuggestions() {
      this.$emit("suggestion", this.searchSuggestions);
    }
  },

  created() {
    this.loadCurrencyListFromApi();
  },

  mounted() {
    if (this.searchValue) {
      this.handleSearchSuggestions(this.searchValue);
    }
  }
}
</script>

<style scoped>

</style>